<?php namespace Phpcmf\Controllers;

class Home extends \Phpcmf\App
{
    public function __construct(...$params)
    {
        parent::__construct($params);

        //页面title
        \Phpcmf\Service::V()->assign([
            'meta_title'   => '全站搜索',
        ]);
    }

    // 建立分页链接
    public function mypage($url, $total,$pagesize) {
        $config = require ROOTPATH.'config/page/pc/page.php';
        $config['base_url'] = $url.'&page={page}';
        if ($pagesize==0)
            $config['per_page'] = SYS_ADMIN_PAGESIZE;
        else
            $config['per_page'] =$pagesize;
        $config['total_rows'] = $total;
        return \Phpcmf\Service::L('page')->initialize($config)->create_links();
    }

    public function index(){

        //配置信息
        $config = \Phpcmf\Service::M('app')->get_config(APP_DIR);
        $mdir = \Phpcmf\Service::M('app')->get_config(APP_DIR); //可搜索模型

        $modelAll = \Phpcmf\Service::L('cache')->get('module-'.SITE_ID.'-content'); //遍历所有模块

        //参数
        $keyword = trim(\Phpcmf\Service::L('input')->get('keyword'));  //搜索词
        $page    = \Phpcmf\Service::L('input')->get('page');     //当前页码
        $scope   = dr_safe_replace(\Phpcmf\Service::L('input')->get('scope')); //指定搜索时间范围
        $mid      = \Phpcmf\Service::L('input')->get('mid'); //栏目模型获取
        $cid     = \Phpcmf\Service::L('input')->get('cid');//栏目id获取

        //数据表前缀
        $dbprefix = \Phpcmf\Service::M()->db->DBPrefix;

        //开启入库/统计次数
        if($config['auto_save']==1){
            //查询/入库
            $keyget = \Phpcmf\Service::M()->db->table($dbprefix.SITE_ID."_search_log")->where('keyword',$keyword)->get()->getResultArray();

            if($keyword!=$keyget[0][keyword]){
                //记录日志
                \Phpcmf\Service::M()->db->table($dbprefix.SITE_ID.'_search_log')->insert(['keyword' => $keyword]);
            }else{
                //查询次数
                \Phpcmf\Service::M()->db->table($dbprefix.SITE_ID.'_search_log')->where('keyword', $keyword)->set('hits', 'hits + 1', false)->update();
            }
        }

        //查询字段
        $fileds=' title,thumb,keywords,description,inputtime,updatetime,url,hits '; //字段
        //查询条件 标题/关键字/描述
        $where =" where (title like '%$keyword%' OR keywords like '%$keyword%' OR description like '%$keyword%') ";
        //排序规则
        $order =' order by inputtime desc';

        //分页数量
        if($config['pagesize']!=''){
            $limit = $config['pagesize'];
        }else{
            $limit = 10;
        }

        //时间范围条件
        if ($scope=='day') {
            $where.=' and inputtime>='. strtotime(date('Y-m-d').' 01:01:01');
        }else if ($scope=='week') {
            $where.=' and inputtime>='. strtotime(date('Y-m-d',strtotime('-7 days')).' 01:01:01');
        }else if ($scope=='month') {
            $where.=' and inputtime>='. strtotime(date('Y-m-d',strtotime('-31 days')).' 01:01:01');
        }else if ($scope=='week') {
            $where.=' and inputtime>='. strtotime(date('Y-m-d',strtotime('-365 days')).' 01:01:01');
        }

        //数据集
        $data="";
        //数据统计
        $data_total = "";

        if($mid==''){
            if($mdir['dirname']!=''){
                foreach($mdir['dirname'] as $v){
                    if ($data!='') {
                        $data.=' UNION ALL ';
                        $data_total.=' UNION ALL ';
                    }
                    $data .= ' SELECT '.$fileds.' FROM '.$dbprefix.SITE_ID.'_'.$v.$where;
                    $data_total .= 'SELECT count(*) as b FROM '.$dbprefix.SITE_ID.'_'.$v.$where;
                }
            }else{
                foreach($modelAll as $v){
                    if ($data!='') {
                        $data.=' UNION ALL ';
                        $data_total.=' UNION ALL ';
                    }
                    $data .= ' SELECT '.$fileds.' FROM '.$dbprefix.SITE_ID.'_'.$v['dirname'].$where;
                    $data_total .= 'SELECT count(*) as b FROM '.$dbprefix.SITE_ID.'_'.$v['dirname'].$where;
                }
            }
        }else{
            if($cid!=''){
                $data .= ' SELECT '.$fileds.' FROM '.$dbprefix.SITE_ID.'_'.$mid.$where.' AND catid='.$cid;
                $data_total .= 'SELECT count(*) as b FROM '.$dbprefix.SITE_ID.'_'.$mid.$where.' AND catid='.$cid;
            }else{
                $data .= ' SELECT '.$fileds.' FROM '.$dbprefix.SITE_ID.'_'.$mid.$where;
                $data_total .= 'SELECT count(*) as b FROM '.$dbprefix.SITE_ID.'_'.$mid.$where;
            }
        }


        //统计
        $dataAll_total = 'SELECT sum(b) as num FROM ('.$data_total.' ) a ';
        $list_total = \Phpcmf\Service::M()->db->query($dataAll_total)->getRowArray();
        $total_nums = $list_total['num'];

        //分页处理
        if($page==''){
            $limits =' limit '.$limit;
        }else{
            $limits =' limit '.($page-1)*$limit.','.$limit;
        }
        $dataAll = ' SELECT * FROM ('.$data.' ) a '.$order.$limits;
        $list = \Phpcmf\Service::M()->db->query($dataAll)->getResultArray();


        //数据输出
        \Phpcmf\Service::V()->assign([
            'keyword'       => $keyword,  //关键词
            'model'         => $modelAll,  //模型
            'scope'         => $scope,    //查询范围
            'list'          => $list,     //数据集
            'total_nums'    => $total_nums,  //内容数量
            'mypage'	    => $this->mypage(\Phpcmf\Service::L('Router')->url('search/home/index', ['keyword' => $keyword,'mid'=>$mid,'cid'=>$cid,'scope'=>$scope]), $total_nums,$limit),
        ]);

        //输出模板
        \Phpcmf\Service::V()->display('search_all.html');
    }
}
